﻿using System.ComponentModel;
using System.Web.Mvc;
using pavliks.PortalConnector.Mvc.Engine.Models;
using pavliks.PortalConnector.Mvc.Resources;
using SitefinityWebApp.Mvc.Models.ColorPicker;
using Telerik.Sitefinity.Data.Metadata;
using Telerik.Sitefinity.Frontend.Mvc.Infrastructure.Controllers;
using Telerik.Sitefinity.Frontend.Mvc.Infrastructure.Controllers.Attributes;
using Telerik.Sitefinity.Model;
using Telerik.Sitefinity.Modules.Pages.Configuration;
using Telerik.Sitefinity.Modules.Pages.Web.Services;
using Telerik.Sitefinity.Mvc;
using Telerik.Sitefinity.Web.UI.Fields.Enums;

namespace SitefinityWebApp.Mvc.Controllers
{
[DatabaseMapping(UserFriendlyDataType.LongText)]
[Localization(typeof(PortalConnectorMvcResources))]
[ControllerToolboxItem(Name = "Color Picker", Title = "Color Picker", SectionName = "The Portal Connector", Toolbox = "FormControls")]
public class ColorPickerController : TpcFormWidgetController<ColorPickerModel>
    {
        private ColorPickerModel model;

        public ColorPickerController()
        {
            this.DisplayMode = FieldDisplayMode.Write;
        }

        [TypeConverter(typeof(ExpandableObjectConverter))]
        [ReflectInheritedProperties]
        public override ColorPickerModel Model
        {
            get { return model ?? (model = ControllerModelFactory.GetModel<ColorPickerModel>(GetType())); }
        }

        protected override ViewResult View(object value, string templateName)
        {
            templateName = "Write.Default";

	        return View(templateName, Model.GetViewModel(value, MetaField));
        }
    }
}
