using System.Text;
using pavliks.PortalConnector.Mvc.Engine.Interfaces;
using pavliks.PortalConnector.Mvc.Engine.Models;
using pavliks.PortalConnector.Mvc.Engine.Models.Enums;
using Telerik.Sitefinity.Metadata.Model;

namespace SitefinityWebApp.Mvc.Models.ColorPicker
{
    public class ColorPickerModel : TpcFormFieldModel, IHideableWidget, IEditableField, IHasTitle
    {
        public ColorPickerModel()
        {
        }
        
        #region Properties
        
        public bool IsHidden { get; set; }
        public bool ReadOnly { get; set; }
        public bool HideTitle { get; set; }

        public LabelPosition LabelPosition { get; set; }
        public string RequiredIndicationLabel { get; set; }

        #endregion

        public override object GetViewModel(object value, IMetaField metaField)
        {
            return new ColorPickerViewModel
            {
                Value = Value,
                MetaField = metaField,
                CssClass = CssClass,
                ReadOnly = ReadOnly,
                IsHidden = IsHidden,
                HideTitle = HideTitle,
                LabelPosition = LabelPosition,
                RequiredIndicationLabel = RequiredIndicationLabel,
                ValidationAttributes = BuildValidationAttributes(),
                ValidatorDefinition = ValidatorDefinition,
                ClientSideRequired = ClientSideRequired,
                ToolTip = ToolTip,
				ToolTipAttributes = BuildToolTipAttributes()
            };
        }
        
        protected override string BuildValidationAttributes()
        {
            var attributes = new StringBuilder();

            if (ClientSideRequired || (ValidatorDefinition.Required.HasValue && ValidatorDefinition.Required.Value))
            {
                attributes.Append("required='required'");
                attributes.Append("aria-required='true'");
                attributes.AppendFormat("data-required-msg='{0}' ", ValidatorDefinition.RequiredViolationMessage);
            }

            return attributes.ToString();
        }
    }
}